// static/nativeComponents/PhotoGallery/index.js
let app = getApp()
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    datas: {
      type: Object
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    getPaddingList: [{
      'name': '上',
      'value': 0
    },
    {
      'name': '下',
      'value': 0
    },
    {
      'name': '左',
      'value': 0
    },
    {
      'name': '右',
      'value': 0
    }
    ],
    imgArr : [],
    imgList: [],
    lenI : 0,
    WaterfallFlowListL : [],
    WaterfallFlowListR: [],
    showImg: false,
  },
  ready(){
    if (this.data.datas.componentData.paddingList){
      this.setData({
        getPaddingList: this.data.datas.componentData.paddingList,
        imgList: this.data.datas.componentData.imgList
      })
    }
    console.log(this.data.getPaddingList[2],this.data.getPaddingList[3],'--------------------45')
    if(this.data.datas.componentData.style == 'waterfall'){
      console.log(this.data.datas.componentData,'图片画廊waterfall')
      let list = this.data.datas.componentData.imgList
      let WaterfallFlowListL = []
      let WaterfallFlowListR = []

      this.setData({
        WaterfallFlowListL: [],
        WaterfallFlowListR: []
      })

      list.forEach(((item,index) => {
        if (index % 2 == 0) {
          WaterfallFlowListL.push(item)
        } else {
          WaterfallFlowListR.push(item)
        }
      }))

      this.setData({
        ['WaterfallFlowListL']: WaterfallFlowListL,
        ['WaterfallFlowListR']: WaterfallFlowListR
      })

      console.log(this.data.WaterfallFlowListL,this.data.WaterfallFlowListR,'图片画廊数据')

    }


    this.data.datas.componentData.imgList.forEach((item,index) => {
      this.setData({
        ['imgArr[' + index + '].width'] : '',
        ['imgArr[' + index + '].height']: ''
      })
    })
  },

  /**
   * 组件的方法列表
   */
  methods: {
    itemClick(e){
      let item = e.currentTarget.dataset.item
      app.trackCpn(e, this.data.datas.componentName, item)
      app.$themeToLink(item.link)
    },
    bindload(e) {
      let { imgList } = this.data;
      console.log(e,'宽高')
      let _this = this;
      let index = e.currentTarget.dataset.index;
      let width = e.detail.width
      let height = e.detail.height

      console.log(index,width,height)

      this.setData({
        lenI : this.data.lenI + 1
      })

      this.setData({
        ['imgArr[' + index + '].width']: width,
        ['imgArr[' + index + '].height']: height
      })

      if (this.data.lenI == this.data.datas.componentData.imgList.length){
          let countWidth = 0;
          this.data.imgArr.forEach(item => {
            countWidth += Number(item.width)
          })

        console.log(countWidth,'countWidth')

        const res = wx.getSystemInfoSync()

        let getPaddingListLeft = this.data.getPaddingList[2].value;
        let getPaddingListRight = this.data.getPaddingList[3].value;
        console.log(getPaddingListLeft,getPaddingListRight,'---getPaddingListRight')
        let b = countWidth / (res.windowWidth - getPaddingListLeft - getPaddingListRight)

        console.log(b,'nnnnn')
        this.data.imgArr.forEach((it,ii) => {
          console.log(it.width / b,Math.ceil(it.width / b),'---Math.ceil(it.width / b)')
          this.setData({
            ['imgArr[' + ii + '].width']: it.width / b ,
            ['imgArr[' + ii + '].height']: it.height /b
          })
        })
        this.setData({
          showImg: true,
        })
      }
      let query = wx.createSelectorQuery().in(this);
      query
        .selectAll(".imgBox")
        .boundingClientRect(rect => {
          rect && rect.map((item, index) => {
            Math.ceil(item.width);
            console.log('imgBox-width', Math.ceil(item.width));
            let ratio = Math.ceil(item.width) / imgList[index].imgWidth;
            console.log('ratio', ratio)
            imgList[index].hotList && imgList[index].hotList.forEach((item1, index1) => {
              item1.renderWidth = item1.width * ratio;
              item1.renderHeight = item1.height * ratio;
              item1.renderTop = item1.top * ratio;
              item1.renderLeft = item1.left * ratio;
            })
            console.log('imgList', imgList)
          })
          _this.setData({
            imgList,
          })
        })
        .exec();
    }
  }
})
